// GetPasswordDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetPasswordApp.h"
#include "GetPasswordDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGetPasswordDlg dialog

CGetPasswordDlg::CGetPasswordDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetPasswordDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGetPasswordDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

BEGIN_MESSAGE_MAP(CGetPasswordDlg, CDialog)
	//{{AFX_MSG_MAP(CGetPasswordDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_Go, OnGo)
	ON_BN_CLICKED(IDC_6, On6)
	ON_BN_CLICKED(IDC_7, On7)
	ON_BN_CLICKED(IDC_8, On8)
	ON_BN_CLICKED(IDC_9, On9)
	ON_CBN_SELCHANGE(IDC_Pattern, OnSelchangePattern)
	ON_BN_CLICKED(IDC_Copy, OnCopy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetPasswordDlg message handlers

BOOL CGetPasswordDlg::OnInitDialog() {
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

  Font.CreateStockObject(ANSI_FIXED_FONT);
  GetDlgItem(IDC_Password   )->SetFont(&Font);
  GetDlgItem(IDC_Pattern    )->SetFont(&Font);
  GetDlgItem(IDC_PatternText)->SetFont(&Font);

	((CButton*)GetDlgItem(IDC_9))->SetCheck(1);
  ((CComboBox*)GetDlgItem(IDC_Pattern))->SetCurSel(0);
	OnGo();
	GetDlgItem(IDC_Go)->SetFocus();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGetPasswordDlg::OnPaint() {
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
  }else CDialog::OnPaint();
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGetPasswordDlg::OnQueryDragIcon() {return (HCURSOR) m_hIcon;}

void CGetPasswordDlg::OnGo() {
  int CB=0;
	     if(((CButton*)GetDlgItem(IDC_6))->GetCheck()) CB=6;
	else if(((CButton*)GetDlgItem(IDC_7))->GetCheck()) CB=7;
	else if(((CButton*)GetDlgItem(IDC_8))->GetCheck()) CB=8;
	else if(((CButton*)GetDlgItem(IDC_9))->GetCheck()) CB=9;
  CComboBox* Pat=(CComboBox*)GetDlgItem(IDC_Pattern);
  GP.New(CB, Pat->GetCurSel()-1);
	SetDlgItemText(IDC_Password   , GP.GetPassword());
  SetDlgItemText(IDC_PatternText, GP.GetPattern().Left(CB));
  if(Pat->GetCurSel()) Pat->SetCurSel(GP.GetPatternIdx()+1);
}

void CGetPasswordDlg::On6() {OnGo();}
void CGetPasswordDlg::On7() {OnGo();}
void CGetPasswordDlg::On8() {OnGo();}
void CGetPasswordDlg::On9() {OnGo();}
void CGetPasswordDlg::OnSelchangePattern() {
  CComboBox* Pat=(CComboBox*)GetDlgItem(IDC_Pattern);
  GP.SetPattern(Pat->GetCurSel()-1);
	SetDlgItemText(IDC_Password   , GP.GetPassword());
	SetDlgItemText(IDC_PatternText, GP.GetPattern ());
}

void CGetPasswordDlg::OnCopy() {
  CString Clip;
	GetDlgItemText(IDC_Password, Clip);
// Allocate memory and copy the string to it
  HANDLE hData; // handle  to clip data
  LPSTR lpData; // pointer to clip data
  if(!(hData =GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE, Clip.GetLength()+1))) return;
  if(!(lpData=(LPSTR)GlobalLock(hData))) return;
  lstrcpy(lpData, Clip.GetBuffer(0));
  GlobalUnlock(hData);
// Clear the current contents of the clipboard, and set
// the data handle to the new string.
  if(!OpenClipboard()) return;
  EmptyClipboard();
  SetClipboardData(CF_TEXT, hData);
  CloseClipboard();
}
